<template>
	<div class="d-inline-flex">
		<v-btn class="px-4" @click="showConfirmationDialog = true" v-bind="$attrs" icon><v-icon>mdi-delete</v-icon></v-btn>
		<confirm-dialog
			v-model="showConfirmationDialog"
			:title="`Delete ${group.name}`"
			:error="errorMessage"
			message="This group, all descendant groups and all memberships in all of those groups will be PERMANENTLY DELETED. Are you sure you want to delete?"
			button="Delete"
			button-color="error"
			:loading="isLoading"
			@confirm="handleConfirmDelete"
			persistent
			@cleanup="handleCleanup"
		/>
	</div>
</template>

<script lang="ts">
import { computed, defineComponent, ref } from '@vue/composition-api';
import ConfirmDialog from '@/components/dialog/ConfirmDialog.vue';
import soilApiService from '@/services/soilApiService';
import { Group } from '@/store/types';

export default defineComponent({
	components: { ConfirmDialog },
	inheritAttrs: false,
	props: {
		group: {
			type: Object as () => Group,
			required: true,
		},
	},
	setup(props, { root }) {
		const showConfirmationDialog = ref<boolean>(false);
		const deleteError = ref();
		const isLoading = ref(false);

		const errorMessage = computed<string>(() =>
			deleteError.value
				? deleteError.value?.response?.data?.message ||
				  'An error occurred while attempting to delete the group. Please try again.'
				: ''
		);

		const handleConfirmDelete = async () => {
			try {
				isLoading.value = true;
				await soilApiService.deleteGroup({ groupId: props.group.id });
				showConfirmationDialog.value = false;
			} catch (err) {
				deleteError.value = err;
			} finally {
				isLoading.value = false;
			}
		};

		const handleCleanup = () => {
			deleteError.value = null;
			isLoading.value = false;
			root.$store.dispatch('groups/getGroups');
		};

		return {
			showConfirmationDialog,
			handleConfirmDelete,
			isLoading,
			errorMessage,
			handleCleanup,
		};
	},
});
</script>

<style></style>
